/*
 * stokes.c
 *   H 䐪 (ǂ Ƃ䂫) N쐬̃vO (1995N2) ኱C
 *     0. ANSI C ̃vg^Cv錾
 *     1. ߂
 *     2. ϐ̏Y𒼂
 *     3. s̐ςvZ֐ŏo͂͂Ɋ܂܂ĂĂ NG Ȃ̂ŏC
 *          CO    matprod1(a,d,6,6,1,d);
 *          C    matprod1(a,w,6,6,1,d);  w ͐V
 *   ɒׂƂ
 *     L, L2 ̃TCYŒ...
 */

#include <math.h>
#include <stdio.h>
#include "matutil.h"

#define  L  50000
#define L2 500000

/* vg^Cv錾 */
double menseki(double, double, double, double, double, double);
void matprod1(matrix, matrix, int, int, int, matrix);
void matprod2(matrix, matrix, matrix, int, int, int, int, matrix);
void make(int, matrix, vector, double, double, vector, vector, int **,
	  int *, vector, vector, vector, vector);
void change(matrix, int, int);
void bound(matrix, vector, int *, vector, vector, int, int, int *, int);
void etalu(matrix, vector, int);
static void updtel(vector, int *, int *, vector, int *, int);
static void updteu(vector, int *, int *, vector, int);

int main(int argc, char **argv)
{
  /****************** ϐ錾 ********************/
    int i, j;
    /* ̓t@C, o̓t@C */
    FILE *f1, *f2;
    /* U: ߓ_̑, T: vf̑, SIZE: m̑ */
    int U, T, SIZE;
    /* N: Neumann B.C. ۂߓ_̑, D: Dirichlet B.C. ۂߓ_̑ */
    int N, D;
    /* ND == D + N */
    int ND;
    /*
     *  cum[U]: ݐϐߓ_ԍ\,
     *  num[T][6]: vfߓ_ԍ\ (evf\ߓ_̑S̐ߓ_ԍW߂\)
     */
    int *cum, **num, *b;
    /* nu: SW , rho: x  */
    double nu, rho;
    /* x[U], y[U]: ߓ_̍W,
       bx[ND], by[ND]: Ef[^,
       fx[], fy[]: ,
       sx[], sy[]:  */
    vector x, y, u, bx, by, fx, fy, sx, sy;
    /* o[SIZE][SIZE]: S̍s */
    matrix o;
  /**************** ϐ錾I, ȉs ******************/

    /* ̌`FbN */
    if (argc != 3) {
	fprintf(stderr, "usage: %s <input_file_name> <output_file_name>\n",
		argv[0]);
	exit(1);
    }
    /* ̓t@CI[v */
    if ((f1 = fopen(argv[1], "r")) == NULL) {
	fprintf(stderr, "Can't open %s", argv[1]);
	exit(1);
    }
    /* o̓t@CI[v (IWił͌vZɂAOɊJׂ) */
    if ((f2 = fopen(argv[2], "w")) == NULL) {
	printf("Can't open %s", argv[2]);
	exit(2);
    }
    /* vf T, ߓ_ U ǂݍ */
    fscanf(f1, "%d %d", &T, &U);

    /* ߓ_̍W (x,y) ǂݍ */
    x = new_vector(U);
    y = new_vector(U);
    for (i = 0; i < U; i++) {
	fscanf(f1, "%lf %lf", &x[i], &y[i]);
    }

    /* vfߓ_ԍ\ num[T][6] m */
    num = (int **) malloc(T * sizeof(int *));
    if (num == NULL) {
	fprintf(stderr, "vfƐߓ_̑Ήp̃[܂\n");
	exit(1);
    }
    for (i = 0; i < T; i++) {
	num[i] = (int *) malloc(sizeof(int) * 6);
	if (num[i] == NULL) {
	    fprintf(stderr, "vfƐߓ_̑Ήp̃[܂\n");
	    exit(1);
	}
    }
    /* num[T][6] ǂݍ */
    for (i = 0; i < T; i++)
	for (j = 0; j < 6; j++)
	    fscanf(f1, "%d", &num[i][j]);

    /* ݐϐߓ_ԍ\ cum[U] m */
    if ((cum = (int *) malloc(sizeof(int) * U)) == NULL) {
	fprintf(stderr, "ݐϐߓ_ԍp̃[܂ \n");
	exit(1);
    }
    /* cum[U] ǂݍ */
    for (i = 0; i < U; i++)
	fscanf(f1, "%d", &cum[i]);

    /* m̑ SIZE ǂݍ */
    fscanf(f1, "%d", &SIZE);

    /* A1 o x = u ̂߂̕ϐ o[SIZE][SIZE], u[SIZE] m */
    u = new_vector(SIZE);
    o = new_matrix(SIZE, SIZE);
    for (i = 0; i < SIZE; i++) {
	u[i] = 0.0;
	for (j = 0; j < SIZE; j++)
	    o[i][j] = 0.0;
    }

    /* SW nu, x rho ǂݍ */
    fscanf(f1, "%lf %lf", &nu, &rho);
    /* Dirichlet E, Neumann E̐ߓ_̑ N, D ǂݍ */
    fscanf(f1, "%d %d", &D, &N);

    /* E̐ړ_̑ ND vZ */
    ND = N + D;

    /* Ef[^L bx[ND], by[ND] pӂAǂݍ */
    if ((b = (int *) malloc(sizeof(int) * ND)) == NULL) {
	printf("E̔ԍp̃[܂B\n");
    }
    bx = new_vector(ND);
    by = new_vector(ND);
    for (i = 0; i < ND; i++)
	fscanf(f1, "%d %lf %lf", &b[i], &bx[i], &by[i]);

    /* Neumann Ef[^\킷 sx[U],sy[U] p */
    sx = new_vector(U);
    sy = new_vector(U);
    for (i = 0; i < U; i++)
	sx[i] = sy[i] = 0.0;
    if (N != 0) {		/* c Neumann EłȂȂ */
	for (i = D; i < ND; i++) {	/* : ŏ D  Dirichlet f[^ */
	    sx[b[i]] = bx[i];
	    sy[b[i]] = by[i];
	}
    }
    /* O fx[U], fy[U] mۂAǂݍ */
    fx = new_vector(U);
    fy = new_vector(U);
    for (i = 0; i < U; i++)
	fscanf(f1, "%lf %lf", &fx[i], &fy[i]);

    /* ̓f[^ǂݍݏI */
    fclose(f1);

    /* A1 */
    make(T, o, u, nu, rho, x, y, num, cum, fx, fy, sx, sy);
    bound(o, u, b, bx, by, N, D, cum, SIZE);

    /* svɂȂ[ԋp */
    free(num);
    free_vector(x);
    free_vector(y);
    free_vector(fx);
    free_vector(fy);

    free(b);
    free(cum);
    free_vector(bx);
    free_vector(by);

    /* A1 */
    etalu(o, u, SIZE);

    /* vZʂt@C f2 ɏo͂At@C */
    for (i = 0; i < SIZE; i++)
	fprintf(f2, "%f \n", u[i]);
    fclose(f2);

    return 0;
}

/* Op`̒_̍W (t) ʐςvZ */
double menseki(double x0, double x1, double x2,
	       double y0, double y1, double y2)
{
    double s;
    s = 0.5 * ((x1 - x0) * (y2 - y0) - (y1 - y0) * (x2 - x0));
    return s;
}

/*
 * (l,m) ^s a  (m,n) ^s b ̐ς c ɑ
 *  v c=a*b
 */
void matprod1(matrix a, matrix b, int l, int m, int n, matrix c)
{
    double s;
    int i, j, k;

    for (i = 0; i < l; i++)
	for (j = 0; j < n; j++) {
	    s = 0.0;
	    for (k = 0; k < m; k++)
		s += a[i][k] * b[k][j];
	    c[i][j] = s;
	}
}

/*
 * (k,l) ^s a  (l,m) ^s b, (m,n) ^s c ̐ς d ɑ
 *  v d=a*b*c
 */
void matprod2(matrix a, matrix b, matrix c, int k, int l, int m, int n,
	      matrix d)
{
    matrix p = new_matrix(k, m);

    matprod1(a, b, k, l, m, p);
    matprod1(p, c, k, m, n, d);

    free_matrix(p);
}

/*
 * `\킷A1B
 * envOŌ ecm(), assem() 킹e
 */
void make(int T, matrix o, vector u, double nu, double rho,
	  vector x, vector y, int **num, int *cum,
	  vector fx, vector fy, vector sx, vector sy)
{
    int i, j, k;
    double b1, b2, b3, c1, c2, c3, l1, l2, l3, s, t, nurho;

    matrix a = new_matrix(6, 6);
    matrix ta = new_matrix(6, 6);
    matrix b = new_matrix(6, 6);
    matrix c = new_matrix(6, 6);
    matrix d = new_matrix(6, 1);
    matrix w = new_matrix(6, 1);	/* ͌jc */
    matrix g = new_matrix(3, 3);
    matrix hx = new_matrix(6, 3);
    matrix hy = new_matrix(6, 3);
    matrix mxx = new_matrix(6, 6);
    matrix mxy = new_matrix(6, 6);
    matrix myx = new_matrix(6, 6);
    matrix myy = new_matrix(6, 6);
    matrix r = new_matrix(6, 1);

    nurho = nu * rho;

    /* A, A^T */
    for (i = 0; i < 6; i++)
	for (j = 0; j < 6; j++)
	    a[i][j] = ta[i][j] = b[i][j] = c[i][j] = 0;

    a[0][0] = 1.0;
    a[0][4] = -1.0;
    a[0][5] = -1.0;
    a[1][1] = 1.0;
    a[1][3] = -1.0;
    a[1][5] = -1.0;
    a[2][2] = 1.0;
    a[2][3] = -1.0;
    a[2][4] = -1.0;
    a[3][3] = 4.0;
    a[4][4] = 4.0;
    a[5][5] = 4.0;

    ta[0][0] = 1.0;
    ta[1][1] = 1.0;
    ta[2][2] = 1.0;
    ta[3][1] = -1.0;
    ta[3][2] = -1.0;
    ta[3][3] = 4.0;
    ta[4][0] = -1.0;
    ta[4][2] = -1.0;
    ta[4][4] = 4.0;
    ta[5][0] = -1.0;
    ta[5][1] = -1.0;
    ta[5][5] = 4.0;

    for (k = 0; k < T; k++) {	/* evfɂ */
	int n0, n1, n2;
	n0 = num[k][0];
	n1 = num[k][1];
	n2 = num[k][2];
	s = menseki(x[n0], x[n1], x[n2], y[n0], y[n1], y[n2]);
	if (s < 0.0) {
	    printf(" %d vf̖ʐςɂȂĂ܂I\n", k);
	    exit(0);
	}
	t = 0.5 / s;

	b1 = t * (y[n1] - y[n2]);
	b2 = t * (y[n2] - y[n0]);
	b3 = t * (y[n0] - y[n1]);
	c1 = t * (x[n2] - x[n1]);
	c2 = t * (x[n0] - x[n2]);
	c3 = t * (x[n1] - x[n0]);

	l1 = hypot(x[n2] - x[n1], y[n1] - y[n2]);
	l2 = hypot(x[n2] - x[n0], y[n0] - y[n2]);
	l3 = hypot(x[n0] - x[n1], y[n1] - y[n0]);

	b[0][0] = 2 * b1;
	b[0][4] = b3;
	b[0][5] = b2;
	b[1][1] = 2 * b2;
	b[1][3] = b3;
	b[1][5] = b1;
	b[2][2] = 2 * b3;
	b[2][3] = b2;
	b[2][4] = b1;
	b[3][1] = b3;
	b[3][2] = b2;
	b[4][0] = b3;
	b[4][2] = b1;
	b[5][0] = b2;
	b[5][1] = b1;

	c[0][0] = 2 * c1;
	c[0][4] = c3;
	c[0][5] = c2;
	c[1][1] = 2 * c2;
	c[1][3] = c3;
	c[1][5] = c1;
	c[2][2] = 2 * c3;
	c[2][3] = c2;
	c[2][4] = c1;
	c[3][1] = c3;
	c[3][2] = c2;
	c[4][0] = c3;
	c[4][2] = c1;
	c[5][0] = c2;
	c[5][1] = c1;

	for (i = 0; i < 3; i++)
	    for (j = 0; j < 3; j++)
		if (i != j)
		    g[i][j] = s / 12;
		else
		    g[i][j] = s / 6;

#ifdef ERROR
	for (i = 0; i < 3; i++) {
	    d[i][0] = s / 6;
	    d[i + 3][0] = s / 12;
	}
	matprod1(a, d, 6, 6, 1, r);
#else
	/* r=a*w, w=(s/6,s/6,s/6,s/12,s/12,s/12)^T */
	for (i = 0; i < 3; i++) {
	    w[i][0] = s / 6;
	    w[i + 3][0] = s / 12;
	}
	/* r=a*w */
	matprod1(a, w, 6, 6, 1, r);
#endif
#ifdef ERROR
	d[0][0] = (l2 + l3) / 3;
	d[1][0] = (l3 + l1) / 3;
	d[2][0] = (l1 + l2) / 3;
	d[3][0] = l1 / 6;
	d[4][0] = l2 / 6;
	d[5][0] = l3 / 6;
	matprod1(a, d, 6, 6, 1, d);
#else
	w[0][0] = (l2 + l3) / 3;
	w[1][0] = (l3 + l1) / 3;
	w[2][0] = (l1 + l2) / 3;
	w[3][0] = l1 / 6;
	w[4][0] = l2 / 6;
	w[5][0] = l3 / 6;
	matprod1(a, w, 6, 6, 1, d);
#endif

	/* hx=a*b*g,hy=a*c*g */
	matprod2(a, b, g, 6, 6, 3, 3, hx);
	matprod2(a, c, g, 6, 6, 3, 3, hy);
	/* mxx=hx*b*ta, mxy=hy*b*ta, myx=hx*c*ta, myy=hy*c*ta */
	matprod2(hx, b, ta, 6, 3, 6, 6, mxx);
	matprod2(hy, b, ta, 6, 3, 6, 6, mxy);
	matprod2(hx, c, ta, 6, 3, 6, 6, myx);
	matprod2(hy, c, ta, 6, 3, 6, 6, myy);

	/* ڍ@ */
	for (i = 0; i < 6; i++) {
	    int I = cum[num[k][i]];
	    for (j = 0; j < 6; j++) {
	        int J = cum[num[k][j]];
		o[I][J] += nurho * (2.0 * mxx[i][j] + myy[i][j]);
		o[I][J + 1] += nurho * mxy[i][j];
		o[I + 1][J] += nurho * myx[i][j];
		o[I + 1][J + 1] += nurho * (mxx[i][j] + 2.0 * myy[i][j]);
	    }
	    for (j = 0; j < 3; j++) {
	        int J = cum[num[k][j]];
		o[I][J + 2] = (o[J + 2][I] -= hx[i][j]);
		o[I + 1][J + 2] = (o[J + 2][I + 1] -= hy[i][j]);
	    }
	    u[I] += rho * r[i][0] * fx[num[k][i]] + d[i][0] * sx[num[k][i]];
	    u[I + 1] +=	rho * r[i][0] * fy[num[k][i]] + d[i][0] * sy[num[k][i]];
	}
    }
    /* svȃ[ԋp */
    free_matrix(a);
    free_matrix(ta);
    free_matrix(b);
    free_matrix(c);
    free_matrix(d);
    free_matrix(r);
    free_matrix(g);
    free_matrix(w);
    free_matrix(hx);
    free_matrix(hy);
    free_matrix(mxx);
    free_matrix(mxy);
    free_matrix(myx);
    free_matrix(myy);
}

void change(matrix o, int k, int SIZE)
{
    int i;

    for (i = 0; i < SIZE; i++)
	o[k][i] = 0.0;
    o[k][k] = 1.0;
}

void bound(matrix o, vector u, int *b, vector bx, vector by,
	   int N, int D, int *cum, int SIZE)
{
    int i, j;

    for (i = 0; i < D; i++) {
	j = cum[b[i]];
	change(o, j, SIZE);
	change(o, j + 1, SIZE);
	u[j] = bx[i];
	u[j + 1] = by[i];
    }
    if (N == 0) {
	change(o, 2, SIZE);
	u[2] = 0.0;
    }
}

/* A1 */
void etalu(matrix o, vector u, int SIZE)
{
    int i, j, k, jk, irow;
    int *ia, *ie, *nwk, num, *ne, *ip, is, ier;
    double val, work, piv, eps = 1.0e-14;
    double *a, *e;
    vector x, we, b;

    if ((nwk = (int *) malloc(sizeof(int) * (SIZE + 1))) == NULL) {
	printf("etalu:nwkp̃[܂\n");
    }
    if ((ne = (int *) malloc(sizeof(int) * (2 * (SIZE + 1)))) == NULL) {
	printf("etalu:nep̃[܂\n");
    }
    if ((ip = (int *) malloc(sizeof(int) * (SIZE + 1))) == NULL) {
	printf("etalu:ipp̃[܂\n");
    }
    if ((ia = (int *) malloc(sizeof(int) * L)) == NULL) {
	fprintf(stderr, "etalu: xNg ia p̃[܂\n");
    }
    if ((ie = (int *) malloc(sizeof(int) * L2)) == NULL) {
	fprintf(stderr, "etalu: xNg ie p̃[܂\n");
    }
    if ((a = (double *) malloc(sizeof(double) * L)) == NULL) {
	fprintf(stderr, "etalu: xNg a p̃[܂\n");
    }
    if ((e = (double *) malloc(sizeof(double) * L2)) == NULL) {
	fprintf(stderr, "etalu: xNg e p̃[܂\n");
    }
    x = new_vector(SIZE + 1);
    we = new_vector(SIZE + 1);
    b = new_vector(SIZE + 1);

    k = 1;
    nwk[0] = 0;
    for (i = 0; i < SIZE; i++) {
	for (j = 0; j < SIZE; j++) {
	    if (o[j][i] != 0.0) {
		a[k] = o[j][i];
		ia[k] = j + 1;
		k++;
	    }
	}
	nwk[i + 1] = k - 1;
    }

    for (i = 0; i < SIZE; i++)
	b[i + 1] = u[i];

    if (L <= SIZE) {
	printf("INVALID ARGUMENT. %d %d \n", L, SIZE);
	ier = 2;
	return;
    }

    ier = is = ne[0] = ne[1] = num = 0;

    for (i = 1; i <= SIZE; i++)
	ip[i] = 0;
    for (k = 1; k <= SIZE; k++) {
	for (i = 1; i <= SIZE; i++)
	    we[i] = 0.0;
	for (i = nwk[k - 1] + 1; i <= nwk[k]; i++)
	    we[ia[i]] = a[i];
	if (k != 1) {
	    jk = k - 1;
	    updtel(e, ie, ne, we, ip, jk);
	    /* COMPUTATION OF ETA */
	}
	/* SELECTION OF PIVOT */
	irow = 0;
	val = 0.0;
	for (i = k; i <= SIZE; i++) {
	    work = fabs(we[i]);
	    if (work > val) {
		val = work;
		irow = i;
	    }
	}
	if (val <= eps) {
	    printf("STOP WITH ZERO PIVOT %d \n", k);
	    ier = 1;
	    return;
	}
	ip[k] = irow;
	if (irow != k) {
	    work = we[k];
	    we[k] = we[irow];
	    we[irow] = work;
	}
	/* WRITE(*,*) (WE[i],I=1,M) */
	/* GENERATION OF ETA */
	piv = -1.0 / we[k];
	we[k] = -1.0;
	for (i = k; i <= SIZE; i++) {
	    we[i] *= piv;
	    if (fabs(we[i]) >= eps) {
		num++;
		e[num] = we[i];
		ie[num] = i;
	    }
	}
	ne[2 * k] = num;
	if (k == 1) {
	    ne[3] = ne[2];
	} else {
	    for (i = 1; i < k; i++) {
		if (fabs(we[i]) >= eps) {
		    num++;
		    e[num] = -we[i];
		    ie[num] = i;
		}
	    }
	    ne[2 * k + 1] = num;
	}
    }
    /* COMPUTION OF X */
    for (k = 1; k <= SIZE; k++)
	x[k] = b[k];
    updtel(e, ie, ne, x, ip, SIZE);
    updteu(e, ie, ne, x, SIZE);

    for (k = 0; k < SIZE; k++)
	u[k] = x[k + 1];

    free(ia);
    free(ie);
    free(nwk);
    free(ne);
    free(ip);
    free(a);
    free(e);
    free_vector(x);
    free_vector(we);
    free_vector(b);
}

static void updtel(vector e, int *ie, int *ne, vector we, int *ip, int K)
{
    int i, j, irow;
    double work;

    for (j = 1; j <= K; j++) {
	irow = ip[j];
	if (irow != j) {
	    work = we[j];
	    we[j] = we[irow];
	    we[irow] = work;
	}
	work = we[j];
	we[j] = 0.0;
	for (i = ne[2 * j - 1] + 1; i <= ne[2 * j]; i++) {
	    we[ie[i]] += e[i] * work;
	}
    }
}

static void updteu(vector e, int *ie, int *ne, vector we, int SIZE)
{
    int i, j;
    double work;

    for (j = SIZE; j >= 2; j--)
	if (ne[2 * j] != ne[2 * j + 1]) {
	    work = we[j];
	    for (i = ne[2 * j] + 1; i <= ne[2 * j + 1]; i++)
		we[ie[i]] += e[i] * work;
	}
}
